#include <list>
#include <string.h>
#include <pthread.h>
#include <thread>
#include <fstream>
#include <iostream>
#include <dlfcn.h>
#include "Includes/Logger.h"
#include "Includes/obfuscate.h"
#include "Includes/Utils.h"
#include "KittyMemory/MemoryPatch.h"
#include "Menu/Setup.h"

#define targetLibName OBFUSCATE("libil2cpp.so")

#include "Includes/Macros.h"

#include "Unity/Vector2.h"
#include "Unity/Vector3.h"
#include "Unity/Rect.h"
#include "Unity/Color.h"
#include "NepDraw.h"
#include "ESPManager.h"
/*void *getTransform(void *enemy) {
    static const auto get_Transform_Component = reinterpret_cast<uint32_t(__fastcall *)(void *)>(getAbsoluteAddress(targetLibName, 0x17A9288));
    return (void *) get_Transform_Component(enemy);
}
Vector3 get_position(void *transform) {
    Vector3 position;
    static const auto get_Position_Injected = reinterpret_cast<uint32_t(__fastcall *)(void *, Vector3 &)>(getAbsoluteAddress(targetLibName, 0x17B52A8));
    get_Position_Injected(transform, position);
    return position;
}
Vector3 worldToScreenPoint(void *transform, Vector3 test) {
    Vector3 position;
    static const auto worldToScreenPoint_Injected = reinterpret_cast<uint32_t(__fastcall *)(void *, Vector3, int, Vector3 &)>(getAbsoluteAddress(targetLibName, 0x179D460));
    worldToScreenPoint_Injected(transform, test, 2, position);
    return position;
}
void *get_camera() {
    static const auto get_Main = reinterpret_cast<uint32_t(__fastcall *)()>(getAbsoluteAddress(targetLibName, 0x179DA98));
    return (void *) get_Main();
}
Vector3 getEnemyLocation(void *enemy) {
    return get_position(getTransform(enemy));
}*/

Vector3 worldToScreenPoint(void *transform, Vector3 test) {
    if (!transform) return Vector3();
    Vector3 position;
    static const auto worldToScreenPoint_Injected = reinterpret_cast<uint32_t(__fastcall *)(void *, Vector3, int, Vector3 &)>(getAbsoluteAddress(targetLibName, string2Offset(OBFUSCATE("0x179D460"))));
    worldToScreenPoint_Injected(transform, test, 2, position);
    return position;
}

//Vector3 (*worldToScreenPoint)(void *instance, Vector3 position, int cameraMode);
void *(*get_Camera)();
void *(*get_Transform_Component)(void *instance);
Vector3 (*get_Position)(void *instance);

ESPManager *espManager;
NepEsp es;

bool isESP;

void DrawESP(NepEsp esp, int screenWidth, int screenHeight) {
    if (isESP) {
        esp.DrawText(Color::Yellow(), "TEST", Vector2(screenWidth / 2, screenHeight / 1.2), 17); // Drawing only text doesn't even fix it
        /*if (espManager->enemies->empty()) {
            return;
        }
        for (int i = 0; i < espManager->enemies->size(); i++) {
            void *enemy = (*espManager->enemies)[i]->object;
            Vector3 enemyPos = get_Position(get_Transform_Component(enemy));
            void *cam = get_Camera();
            Vector3 enemyPosNew = worldToScreenPoint(cam, enemyPos);
            if (enemyPosNew.z < 1.f) continue;
            Vector2 drawFrom = Vector2(screenWidth / 2, 0);
            Vector2 drawTo = Vector2((screenWidth - (screenWidth - enemyPosNew.x)) + 5, (screenHeight - enemyPosNew.y - 10.0f));
            esp.DrawLine(Color::Red(), 2, drawFrom, drawTo);
        }*/
    }
}

void (*old_EnemyAIGranny_FixedUpdate)(void *instance);
void EnemyAIGranny_FixedUpdate(void *instance) {
    if (instance != nullptr) {
        /*if (isESP) {
            espManager->tryAddEnemy(instance);
        }*/
    }
    old_EnemyAIGranny_FixedUpdate(instance);
}

void DrawOn(JNIEnv *env, jclass type, jobject espView, jobject canvas) {
    es = NepEsp(env, espView, canvas);
    if (es.isValid()) {
        DrawESP(es, es.getWidth(), es.getHeight());
    }
}

/*extern "C"
JNIEXPORT void JNICALL
Java_com_android_support_Menu_DrawOn(JNIEnv *env, jclass type, jobject espView, jobject canvas) {
    es = NepEsp(env, espView, canvas);
    if (es.isValid()) {
        DrawESP(es, es.getWidth(), es.getHeight());
    }
}*/

void *hack_thread(void *) {
    LOGI(OBFUSCATE("pthread created"));
    do {
        sleep(1);
    } while (!isLibraryLoaded(targetLibName) || !isLibraryLoaded(OBFUSCATE("libBadGame.so")));
    LOGI(OBFUSCATE("%s has been loaded"), (const char *) targetLibName);
    espManager = new ESPManager();
    #if defined(__aarch64__)
    #else
    MSHookFunction((void *)getAbsoluteAddress(targetLibName, string2Offset(OBFUSCATE("0x580698"))), (void *)EnemyAIGranny_FixedUpdate, (void **)&old_EnemyAIGranny_FixedUpdate);

    //worldToScreenPoint = (Vector3 (*)(void *, Vector3, int))getAbsoluteAddress(targetLibName, string2Offset(OBFUSCATE("0x179D3C8")));
    get_Camera = (void *(*)())getAbsoluteAddress(targetLibName, string2Offset(OBFUSCATE("0x179DA98")));
    get_Transform_Component = (void *(*)(void *))getAbsoluteAddress(targetLibName, string2Offset(OBFUSCATE("0x17A9288")));
    get_Position = (Vector3 (*)(void *))getAbsoluteAddress(targetLibName, string2Offset(OBFUSCATE("0x17B52A8")));
    #endif
    if (!iconValid || !initValid || !settingsValid) {
        sleep(5);
        int *p = 0;
        *p = 0;
    }
    return NULL;
}

jobjectArray GetFeatureList(JNIEnv *env, jobject context) {
    jobjectArray ret;
    const char *features[] = {
        OBFUSCATE("1_Toggle_Enemy ESP")
    };
    const int Total_Feature = (sizeof features / sizeof features[0]);
    ret = (jobjectArray) env->NewObjectArray(Total_Feature, env->FindClass(OBFUSCATE("java/lang/String")), env->NewStringUTF(""));
    for (int i = 0; i < Total_Feature; i++) 
        env->SetObjectArrayElement(ret, i, env->NewStringUTF(features[i]));
    return ret;
}

void Changes(JNIEnv *env, jclass clazz, jobject obj, jint featNum, jstring featName, jint value, jboolean boolean, jstring str) {
    LOGD(OBFUSCATE("Feature name: %d - %s | Value: = %d | Bool: = %d | Text: = %s"), featNum, env->GetStringUTFChars(featName, 0), value, boolean, str != NULL ? env->GetStringUTFChars(str, 0) : "");
    switch (featNum) {
        case 1:
            isESP = boolean;
            break;
    }
}

__attribute__((constructor))
void lib_main() {
    pthread_t ptid;
    pthread_create(&ptid, NULL, hack_thread, NULL);
}

int RegisterMenu(JNIEnv *env) {
    JNINativeMethod methods[] = {
        {OBFUSCATE("Icon"), OBFUSCATE("()Ljava/lang/String;"), reinterpret_cast<void *>(Icon)},
        {OBFUSCATE("IconWebViewData"), OBFUSCATE("()Ljava/lang/String;"), reinterpret_cast<void *>(IconWebViewData)},
        {OBFUSCATE("IsGameLibLoaded"), OBFUSCATE("()Z"), reinterpret_cast<void *>(isGameLibLoaded)},
        {OBFUSCATE("Init"), OBFUSCATE("(Landroid/content/Context;Landroid/widget/TextView;Landroid/widget/TextView;)V"), reinterpret_cast<void *>(Init)},
        {OBFUSCATE("SettingsList"), OBFUSCATE("()[Ljava/lang/String;"), reinterpret_cast<void *>(SettingsList)},
        {OBFUSCATE("GetFeatureList"), OBFUSCATE("()[Ljava/lang/String;"), reinterpret_cast<void *>(GetFeatureList)},
        {OBFUSCATE("DrawOn"), OBFUSCATE("(Lcom/android/support/ESPView;Landroid/graphics/Canvas;)V"), reinterpret_cast<void *>(DrawOn)}
    };
    jclass clazz = env->FindClass(OBFUSCATE("com/android/support/Menu"));
    if (!clazz || env->RegisterNatives(clazz, methods, sizeof(methods) / sizeof(methods[0])) != 0) return JNI_ERR;
    return JNI_OK;
}

int RegisterPreferences(JNIEnv *env) {
    JNINativeMethod methods[] = { 
        {OBFUSCATE("Changes"), OBFUSCATE("(Landroid/content/Context;ILjava/lang/String;IZLjava/lang/String;)V"), reinterpret_cast<void *>(Changes)}
    };
    jclass clazz = env->FindClass(OBFUSCATE("com/android/support/Preferences"));
    if (!clazz || env->RegisterNatives(clazz, methods, sizeof(methods) / sizeof(methods[0])) != 0) return JNI_ERR;
    return JNI_OK;
}

int RegisterMain(JNIEnv *env) {
    JNINativeMethod methods[] = {
        {OBFUSCATE("CheckOverlayPermission"), OBFUSCATE("(Landroid/content/Context;)V"), reinterpret_cast<void *>(CheckOverlayPermission)}
    };
    jclass clazz = env->FindClass(OBFUSCATE("com/android/support/Main"));
    if (!clazz || env->RegisterNatives(clazz, methods, sizeof(methods) / sizeof(methods[0])) != 0) return JNI_ERR;
    return JNI_OK;
}

extern "C"
JNIEXPORT jint JNICALL
JNI_OnLoad(JavaVM *vm, void *reserved) {
    JNIEnv *env;
    vm->GetEnv((void **) &env, JNI_VERSION_1_6);
    if (RegisterMenu(env) != 0 || RegisterPreferences(env) != 0 || RegisterMain(env) != 0) return JNI_ERR;
    return JNI_VERSION_1_6;
}